import { PickerColumn } from 'ionic-angular';
import { MultiPickerColumn } from './multi-picker-columns';
import { MultiPickerColumnDays } from './columns/days';
export interface IMultiPickerTypeDateColumns {
    daysCol: MultiPickerColumnDays;
    monthsCol: MultiPickerColumn;
    yearsCol: MultiPickerColumn;
}
export interface IMultiPickerTypeTimeColumns {
    hoursCol: MultiPickerColumn;
    minutesCol: MultiPickerColumn;
    noon?: MultiPickerColumn;
}
export interface IMomentObject {
    years?: number;
    months?: number;
    date?: number;
    hours?: number;
    minutes?: number;
    noon?: number;
}
export declare abstract class MultiPickerType {
    protected _columns: IMultiPickerTypeDateColumns | IMultiPickerTypeTimeColumns;
    columns(): IMultiPickerTypeDateColumns | IMultiPickerTypeTimeColumns;
    dealDoneVisibleBnt(columns: PickerColumn[], button: any): void;
    setDefaultSelectedIndexes(columns: PickerColumn[], pickerValue: string): void;
    protected abstract defaultMoment(pickerValue: string): IMomentObject;
    protected currentMoment(columns: PickerColumn[], pickerValue: string): IMomentObject;
    protected generateOptions(): void;
    protected someSelectedIndexBlank(columns: PickerColumn[]): boolean;
    protected disableInvalid(columns: PickerColumn[], colName: string, pickerColIndex: number, rest: Array<number>): void;
}
